<template>
  <FlexboxLayout
    v-if="isEnable"
    flexDirection="row"
    class="all-option-container"
    justifyContent="space-between"
    alignItems="center"
    paddingLeft="10"
    paddingRight="10"
    paddingTop="10"
    :width="selectorWidth"
    :height="selectorHeight"
  >
    <CountrySelector
      flexGrow="1"
      textColor="white"
      width="25"
      height="14"
      :isShowLabel="false"
      :itemSelect="selectedCountry"
      :dataList="countryOptions"
      @onChangedItemSelect="onItemCountryChanged($event)"
    />

    <LanguageSelector
      flexGrow="1"
      :isShowImage="false"
      :isShowLabel="true"
      textColor="white"
      :itemSelect="selectedLanguage"
      :dataList="languageOptions"
      @onChangedItemSelect="onItemLanguageChanged($event)"
    />

    <CurrencySelector
      flexGrow="1"
      :isShowImage="false"
      :isShowLabel="true"
      textColor="white"
      :itemSelect="selectedCurrency"
      :dataList="currencyDropdown"
      @onChangedItemSelect="onItemCurrencyChanged($event)"
    />
  </FlexboxLayout>
</template>

<script>
import { mapGetters, mapMutations, mapActions } from "vuex";
import { GETTERS, MUTATORS, ACTIONS } from "~/store/menu";
import { GETTERS as MEMBER_GETTERS } from "~/store/member";

import CountrySelector from "~/components/CountrySelector";
import LanguageSelector from "~/components/LanguageSelector";
import CurrencySelector from "~/components/CurrencySelector";
export default {
  components: {
    CountrySelector,
    LanguageSelector,
    CurrencySelector,
  },
  props: {
    selectorWidth: String | Number,
    selectorHeight: String | Number,
  },
  data() {
    return {
    };
  },
  computed: {
    ...mapGetters({
      memberId: MEMBER_GETTERS.MEMBER_ID,
      memberName: MEMBER_GETTERS.MEMBER_NAME,
      menuItems: GETTERS.MENU_ITEMS,
      countryOptions: GETTERS.DROPDOWN_COUNTRIES,
      languageOptions: GETTERS.DROPDOWN_LANGUAGES,
      currencyOptions: GETTERS.DROPDOWN_CURRENCIES,
      selectedLanguage: GETTERS.SELECTED_LANGUAGE,
      selectedCountry: GETTERS.SELECTED_COUNTRY,
      selectedCurrency: GETTERS.SELECTED_CURRENCY
    }),
    isEnable() {
      return (
        this.countryOptions &&
        this.languageOptions &&
        this.currencyOptions &&
        this.selectedLanguage &&
        this.selectedCountry &&
        this.selectedCurrency
      );
    },
    currencyDropdown() {
      if (this.selectedCurrency) {
        return this.currencyOptions.filter(
          currency => currency.Code === this.selectedCurrency
        );
      }
      return this.currencyOptions;
    }
  },
  methods: {
    ...mapMutations({
      setSelectedOption: MUTATORS.SET_SELECTED
    }),
    ...mapActions({
      // loadMenuItems: ACTIONS.LOAD_MENU_ITEMS,
      loadGeoIP: ACTIONS.LOAD_GEOIP_CONFIG
    }),
    onItemCountryChanged(country) {
      this.loadGeoIP(country);
      this.setSelectedOption({ country });
    },
    onItemLanguageChanged(language) {
      this.setSelectedOption({ language });
    },
    onItemCurrencyChanged(currency) {
      this.setSelectedOption({ currency });
    }
  }
};
</script>

<style scoped>
.all-option-container {
  margin-top: 30;
  margin-bottom: 20;
  border-top-width: 1;
  border-bottom-width: 1;
  border-top-color: #fff;
  border-bottom-color: #fff;
  padding-left: 10;
  padding-right: 10;
}
</style>